<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>task45.40</title>
    <!-- Google Font: Source Sans Pro -->
    <link rel="stylesheet"
        href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
    <!-- Font Awesome -->
    <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
    <!-- Theme style -->
    <link rel="stylesheet" href="dist/css/adminlte.min.css">
    <!-- Data Table -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
</head>

<body class="hold-transition sidebar-mini layout-fixed">
    <div class="wrapper">
        <!-- Navbar -->
        <nav class="main-header navbar navbar-expand navbar-white navbar-light">
            <!-- Left navbar links -->
            <ul class="navbar-nav">
                <li class="nav-item d-none d-sm-inline-block">
                    <a href="#" class="nav-link">Danh sách Voucher</a>
                </li>
            </ul>

            <!-- Right navbar links -->
            <ul class="navbar-nav ml-auto">
                <li class="nav-item">
                    <a class="nav-link" data-widget="fullscreen" href="#" role="button">
                        <i class="fas fa-expand-arrows-alt"></i>
                    </a>
                </li>
            </ul>
        </nav>
        <!-- /.navbar -->

        <!-- Main Sidebar Container -->
        <aside class="main-sidebar sidebar-dark-primary elevation-4">
            <!-- Brand Logo -->
            <a href="index3.html" class="#">
                <span class="brand-text font-weight-light">DevCamp120</span>
            </a>
            <!-- Sidebar Menu -->
            <nav class="mt-2">
                <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu"
                    data-accordion="false">
                    <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
                    <li class="nav-item menu-open">
                        <a href="#" class="nav-link active">
                            <i class="nav-icon fas fa-tachometer-alt"></i>
                            <p>
                                Dashboard
                                <i class="right fas fa-angle-left"></i>
                            </p>
                        </a>
                        <ul class="nav nav-treeview">
                            <li class="nav-item">
                                <a href="./index.html" class="nav-link active">
                                    <i class="far fa-circle nav-icon"></i>
                                    <p>Dashboard v1</p>
                                </a>
                            </li>
                            <li class="nav-item">
                                <a href="./index2.html" class="nav-link">
                                    <i class="far fa-circle nav-icon"></i>
                                    <p>Dashboard v2</p>
                                </a>
                            </li>
                            <li class="nav-item">
                                <a href="./index3.html" class="nav-link">
                                    <i class="far fa-circle nav-icon"></i>
                                    <p>Dashboard v3</p>
                                </a>
                            </li>
                        </ul>
                    </li>
                    <li class="nav-item">
                        <a href="pages/widgets.html" class="nav-link">
                            <i class="nav-icon fas fa-th"></i>
                            <p>
                                Widgets
                                <span class="right badge badge-danger">New</span>
                            </p>
                        </a>
                    </li>
                </ul>
            </nav>
            <!-- /.sidebar-menu -->
        </aside>
        <!-- /.sidebar -->

        <!-- Content Wrapper. Contains page content -->
        <div class="content-wrapper">

            <!-- Content Header (Page header) -->
            <div class="content-header">
                <div class="container-fluid">
                    <div class="row mb-2">
                        <div class="col-sm-6">
                            <h1 class="m-0">Danh sách Voucher</h1>
                        </div><!-- /.col -->
                        <div class="col-sm-6">
                            <ol class="breadcrumb float-sm-right">
                                <li class="breadcrumb-item"><a href="#">Home</a></li>
                                <li class="breadcrumb-item active">Voucher list</li>
                            </ol>
                        </div><!-- /.col -->
                    </div><!-- /.row -->
                </div>
                <!-- /.container-fluid -->
                <section class="content">
                    <div class="container-fluid">
                        <!-- Vùng header -->
                        <div class="container">
                            <div class="text-center">
                                <h2>Danh sách người dùng đăng ký</h2>
                            </div>
                            <div class="form-group">
                                <button class="btn btn-success" id="btn-add-user"><i class="fa fa-plus"></i>&nbsp; New
                                    User</button>
                            </div>
                        </div>

                        <!-- Vouche Data Table -->
                        <div class="container">
                            <table class="table table-bordered table-striped table-hover" id="user-table">
                                <thead>
                                    <tr>
                                        <th>Id</th>
                                        <th>Firstname</th>
                                        <th>Lastname</th>
                                        <th>Country</th>
                                        <th>Subject</th>
                                        <th>Customer Type</th>
                                        <th>Register Status</th>
                                        <th>Action</th>
                                    </tr>
                                </thead>
                            </table>
                        </div>
                        <!-- thêm User -->

                        <div>
                            <div id="update-user-modal" class="modal fade" tabindex="-1">
                                <div class="modal-dialog">
                                    <div class="modal-content">
                                        <div class="modal-header">
                                            <h5 class="modal-title" id="h5-modal-title">Update User</h5>
                                            <button class="close" data-dismiss="modal">&times;</button>
                                        </div>
                                        <div class="modal-body">
                                            <form>
                                                <div class="row form-group">
                                                    <div class="col-sm-4">
                                                        <label>First name</label>
                                                    </div>
                                                    <div class="col-sm-8">
                                                        <input id="input-firstname" class="form-control">
                                                    </div>
                                                </div>
                                                <div class="row form-group">
                                                    <div class="col-sm-4">
                                                        <label>Last name</label>
                                                    </div>
                                                    <div class="col-sm-8">
                                                        <input id="input-lastname" class="form-control">
                                                    </div>
                                                </div>
                                                <div class="row form-group">
                                                    <div class="col-sm-4">
                                                        <label>Subject</label>
                                                    </div>
                                                    <div class="col-sm-8">
                                                        <input id="input-subject" class="form-control">
                                                    </div>
                                                </div>
                                                <div class="row form-group">
                                                    <div class="col-sm-4">
                                                        <label>Country</label>
                                                    </div>
                                                    <div class="col-sm-8">
                                                        <select id="select-update-subject" class="form-control">
                                                            <option value="NOT_SELECT_COUNTRY"> select country </option>
                                                            <option value="VN"> Việt Nam </option>
                                                            <option value="USA"> USA </option>
                                                            <option value="AUS"> Australia </option>
                                                            <option value="CND"> Canada </option>
                                                        </select>
                                                    </div>
                                                </div>
                                            </form>
                                        </div>
                                        <div class="modal-footer">
                                            <button class="btn btn-primary" id="btn-create-user">Insert User</button>
                                            <button class="btn btn-danger" id="btn-Cancel"
                                                data-dismiss="modal">Cancel</button>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <!-- modal sửa -->
                        <div>
                            <div id="update-user-modal-sua" class="modal fade" tabindex="-1">
                                <div class="modal-dialog">
                                    <div class="modal-content">
                                        <div class="modal-header">
                                            <h5 class="modal-title" id="h5-modal-title">Sửa User</h5>
                                            <button class="close" data-dismiss="modal">&times;</button>
                                        </div>
                                        <div class="modal-body">
                                            <form>
                                                <div class="row form-group">
                                                    <div class="col-sm-4">
                                                        <label>First name</label>
                                                    </div>
                                                    <div class="col-sm-8">
                                                        <input id="input-firstname-sua" class="form-control">
                                                    </div>
                                                </div>
                                                <div class="row form-group">
                                                    <div class="col-sm-4">
                                                        <label>Last name</label>
                                                    </div>
                                                    <div class="col-sm-8">
                                                        <input id="input-lastname-sua" class="form-control">
                                                    </div>
                                                </div>
                                                <div class="row form-group">
                                                    <div class="col-sm-4">
                                                        <label>Subject</label>
                                                    </div>
                                                    <div class="col-sm-8">
                                                        <input id="input-subject-sua" class="form-control">
                                                    </div>
                                                </div>
                                                <div class="row form-group">
                                                    <div class="col-sm-4">
                                                        <label>Country</label>
                                                    </div>
                                                    <div class="col-sm-8">
                                                        <select id="select-cuontry-sua" class="form-control">
                                                            <option value="NOT_SELECT_COUNTRY"> Select country </option>
                                                            <option value="VN"> Việt Nam </option>
                                                            <option value="USA"> USA </option>
                                                            <option value="AUS"> Australia </option>
                                                            <option value="CAN"> Canada </option>
                                                        </select>
                                                    </div>
                                                </div>
                                                <div class="row form-group">
                                                    <div class="col-sm-4">
                                                        <label>Customer Type</label>
                                                    </div>
                                                    <div class="col-sm-8">
                                                        <select class="form-control" id="customer-type-sua">
                                                            <option value="CustomerType">Select Customer Type </option>
                                                            <option value="Standard">Standard</option>
                                                            <option value="Gold">Gold</option>
                                                            <option value="Premium">Premium</option>
                                                        </select>
                                                    </div>
                                                </div>
                                                <div class="row form-group">
                                                    <div class="col-sm-4">
                                                        <label>Register Status</label>
                                                    </div>
                                                    <div class="col-sm-8">
                                                        <select class="form-control" id="inp-register-status-sua">
                                                            <option value="RegisterStatus">Select Register Status
                                                            </option>
                                                            <option value="Accepted">Accepted</option>
                                                            <option value="Denied">Denied</option>
                                                            <option value="Standard">Standard</option>
                                                        </select>
                                                    </div>
                                                </div>
                                            </form>
                                        </div>
                                        <div class="modal-footer">
                                            <button class="btn btn-primary" id="btn-Updata-user">UpdaTa User</button>
                                            <button class="btn btn-danger" id="btn-huy" data-dismiss="modal">Huỹ
                                                bỏ</button>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </section>
            </div>
            <!-- /.content-header -->
        </div>
    </div>
    
    </div>
    
    <!-- jQuery -->
    <script src="plugins/jquery/jquery.min.js"></script>
    <!-- Bootstrap 4 -->
    <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
    <!-- Table -->
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
    <!-- AdminLTE App -->
    <script src="dist/js/adminlte.js"></script>
    <script>
        $(document).ready(function () {

            onPageLoading();

            const gNOT_SELECT_COUMTRY = "NOT_SELECT_COUNTRY";
            const gUSER_ID = 0;
            const gFIRST_NAME = 1;
            const gLAST_NAME = 2;
            const gCOUNTRY = 3;
            const gSUBJECT = 4;
            const gCUSTOMER_TYPE = 5;
            const gREGISTER_STATUS = 6;
            const gACTION = 7;
            const gDATA_COLUMN = [
                "id",
                "firstname",
                "lastname",
                "country",
                "subject",
                "customerType",
                "registerStatus",
                "action"
            ];

            var gId = "";

            function onPageLoading() {
                $.ajax({
                    url: "http://42.115.221.44:8080/crud-api/users/",
                    type: "GET",
                    dataType: "json",
                    success: function (Object) {
                        //console.log(Object);
                        loadDatatoTable(Object);

                    },
                    error: function (error) {
                        console.assert(error.responseText);
                    }

                });

            }


            function loadDatatoTable(paramOjbect) {
                $("#user-table").DataTable({
                    data: paramOjbect,
                    "columns": [
                        { "data": gDATA_COLUMN[gUSER_ID] },
                        { "data": gDATA_COLUMN[gFIRST_NAME] },
                        { "data": gDATA_COLUMN[gLAST_NAME] },
                        { "data": gDATA_COLUMN[gCOUNTRY] },
                        { "data": gDATA_COLUMN[gSUBJECT] },
                        { "data": gDATA_COLUMN[gCUSTOMER_TYPE] },
                        { "data": gDATA_COLUMN[gREGISTER_STATUS] },
                        { "data": gDATA_COLUMN[gACTION] }
                    ],
                    "columnDefs": [
                        {
                            targets: gACTION,
                            defaultContent: `<button class="btn btn-success btn-sua"> Sửa </button> 
                                  <button class="btn btn-danger btn-xoa" data-toggle='modal'> Xoá </button>`
                        }

                    ]
                });
            }

            //click update gọi modal
            $("#btn-add-user").on("click", function () {
                $("#update-user-modal").modal("show");
            })
            // Click sữa gọi modal
            $(document).on("click", ".btn-sua", function () {

                var vRowclick = $(this).closest("tr");
                // tạo biến truy cập vao DataTable
                var vTable = $("#user-table").DataTable();
                // lấy dữ liệu text từ rong click
                var vDataRow = vTable.row(vRowclick).data();
                console.log(vDataRow);
                $("#input-firstname-sua").val(vDataRow.firstname);
                $("#input-lastname-sua").val(vDataRow.lastname);
                $("#input-subject-sua").val(vDataRow.subject);
                $("#select-cuontry-sua").val(vDataRow.country);
                $("#customer-type-sua").val(vDataRow.customerType);
                $("#inp-register-status-sua").val(vDataRow.registerStatus);
                $("#update-user-modal-sua").modal("show");
                var vid = vDataRow.id;
                gId = vid;

            })
            // Updata User 
            $("#btn-Updata-user").on("click", function () {
                console.log(gId);
                upDataUsertoTable();

            })

            var gUserObject = {
                firstname: "",
                lastname: "",
                subject: "",
                country: "",
                registerStatus: "",
                customerType: ""
            };


            function getValeDataUser(paramUser) {
                if (paramUser.firstname == "") {
                    alert("bạn chưa nhập firstname");
                    return false;
                }
                if (paramUser.lastname == "") {
                    alert("bạn chưa nhập lastname");
                    return false;
                }
                if (paramUser.subject == "") {
                    alert("bạn chưa nhập subject");
                    return false;
                }
                if (paramUser.country == gNOT_SELECT_COUMTRY) {
                    alert("bạn chưa chọn country");
                    return false;
                }
                if (paramUser.country == "customerType") {
                    alert("bạn chưa chọn customerType");
                    return false;
                }
                if (paramUser.country == "registerStatus") {
                    alert("bạn chưa chọn registerStatus");
                    return false;
                }

                return true;
            }

            // update data User
            function upDataUsertoTable() {


                getDataUserUpdate(gUserObject);

                var vCheck = getValeDataUser(gUserObject);
                if (vCheck) {
                    $.ajax({

                        url: "http://42.115.221.44:8080/crud-api/users/" + gId,
                        type: "PUT",
                        data: JSON.stringify(gUserObject),
                        contentType: "application/json",
                        success: function (res) {
                            console.log(res);
                            alert("updata thành công!");
                            xoaDataModal();
                            $("#update-user-modal-sua").modal("hide");
                        },
                        error: function (error) {
                            console.assert(error.responseText);
                        }
                    });
                }


            }

            // làm trắng modal
            function xoaDataModal() {
                $("#input-firstname-sua").val("");
                $("#input-lastname-sua").val("");
                $("#input-subject-sua").val("");
                $("#select-update-subject-sua").val("NOT_SELECT_COUMTRY");
                $("#inp-register-status-sua").val("registerStatus");
                $("#customer-type-sua").val("customerType");
            }

            function getDataUserUpdate(paramUser) {
                paramUser.firstname = $("#input-firstname-sua").val().trim();
                paramUser.lastname = $("#input-lastname-sua").val().trim();
                paramUser.subject = $("#input-subject-sua").val().trim();
                paramUser.country = $("#select-cuontry--sua").val();
                paramUser.customerType = $("#customer-type-sua").val();
                paramUser.registerStatus = $("#inp-register-status-sua").val();

            }
        });
    </script>  
</body>
</html>